Index: code/branches/pickup2/src/modules/weapons/weaponmodes/CMakeLists.txt
===================================================================
--- code/branches/pickup2/src/modules/weapons/weaponmodes/CMakeLists.txt	(revision 5942)
+++ code/branches/pickup2/src/modules/weapons/weaponmodes/CMakeLists.txt	(revision 6412)
@@ -5,3 +5,4 @@
   HsW01.cc
   LightningGun.cc
+  RocketFire.cc
 )
Index: code/branches/pickup2/src/modules/weapons/weaponmodes/HsW01.cc
===================================================================
--- code/branches/pickup2/src/modules/weapons/weaponmodes/HsW01.cc	(revision 5942)
+++ code/branches/pickup2/src/modules/weapons/weaponmodes/HsW01.cc	(revision 6412)
@@ -39,4 +39,6 @@
 #include "weaponsystem/WeaponPack.h"
 #include "weaponsystem/WeaponSystem.h"
+#include "worldentities/WorldEntity.h"
+#include "worldentities/pawns/Pawn.h"
 
 namespace orxonox
@@ -56,4 +58,10 @@
         this->delayTimer_.setTimer(1.0f, false, createExecutor(createFunctor(&HsW01::shot, this)));
         this->delayTimer_.stopTimer();
+
+        this->setDefaultSound("sounds/Weapon_HsW01.ogg");
+    }
+
+    HsW01::~HsW01()
+    {
     }
 
@@ -103,4 +111,5 @@
     void HsW01::shot()
     {
+        assert( this->getWeapon() && this->getWeapon()->getWeaponPack() && this->getWeapon()->getWeaponPack()->getWeaponSystem() && this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn() );
         Projectile* projectile = new Projectile(this);
         Model* model = new Model(projectile);
@@ -110,4 +119,5 @@
         model->setScale(5);
 
+        this->computeMuzzleParameters(this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn()->getAimPosition());
         projectile->setOrientation(this->getMuzzleOrientation());
         projectile->setPosition(this->getMuzzlePosition());
Index: code/branches/pickup2/src/modules/weapons/weaponmodes/HsW01.h
===================================================================
--- code/branches/pickup2/src/modules/weapons/weaponmodes/HsW01.h	(revision 5942)
+++ code/branches/pickup2/src/modules/weapons/weaponmodes/HsW01.h	(revision 6412)
@@ -41,5 +41,5 @@
         public:
             HsW01(BaseObject* creator);
-            virtual ~HsW01() {}
+            virtual ~HsW01();
 
             virtual void fire();
Index: code/branches/pickup2/src/modules/weapons/weaponmodes/LightningGun.cc
===================================================================
--- code/branches/pickup2/src/modules/weapons/weaponmodes/LightningGun.cc	(revision 5942)
+++ code/branches/pickup2/src/modules/weapons/weaponmodes/LightningGun.cc	(revision 6412)
@@ -34,4 +34,5 @@
 #include "weaponsystem/WeaponPack.h"
 #include "weaponsystem/WeaponSystem.h"
+#include "worldentities/pawns/Pawn.h"
 
 namespace orxonox
@@ -48,4 +49,5 @@
 
         this->setMunitionName("LaserMunition");
+        this->setDefaultSound("sounds/Weapon_LightningGun.ogg");
     }
 
@@ -59,4 +61,5 @@
         projectile->setMaterial("Flares/LightningBall_");
 
+        this->computeMuzzleParameters(this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn()->getAimPosition());
         projectile->setOrientation(this->getMuzzleOrientation());
         projectile->setPosition(this->getMuzzlePosition());
Index: code/branches/pickup2/src/modules/weapons/weaponmodes/LightningGun.h
===================================================================
--- code/branches/pickup2/src/modules/weapons/weaponmodes/LightningGun.h	(revision 5942)
+++ code/branches/pickup2/src/modules/weapons/weaponmodes/LightningGun.h	(revision 6412)
@@ -42,4 +42,5 @@
 
             virtual void fire();
+
        private:
             float speed_;
Index: code/branches/pickup2/src/modules/weapons/weaponmodes/RocketFire.cc
===================================================================
--- code/branches/pickup2/src/modules/weapons/weaponmodes/RocketFire.cc	(revision 6412)
+++ code/branches/pickup2/src/modules/weapons/weaponmodes/RocketFire.cc	(revision 6412)
@@ -0,0 +1,74 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "RocketFire.h"
+
+#include "util/Math.h"
+#include "core/CoreIncludes.h"
+#include "weapons/projectiles/Rocket.h"
+
+#include "weaponsystem/Weapon.h"
+#include "weaponsystem/WeaponPack.h"
+#include "weaponsystem/WeaponSystem.h"
+#include "worldentities/pawns/Pawn.h"
+
+namespace orxonox
+{
+    CreateFactory(RocketFire);
+
+    RocketFire::RocketFire(BaseObject* creator) : WeaponMode(creator)
+    {
+        RegisterObject(RocketFire);
+
+        this->reloadTime_ = 0.20;
+        this->bParallelReload_ = false;
+        this->damage_ = 100;
+        this->speed_ = 500;
+
+        this->setMunitionName("LaserMunition");
+        // The firing sound of the Rocket is played in Rocket.cc (because of OpenAl sound positioning)
+    }
+
+    RocketFire::~RocketFire()
+    {
+    }
+
+    void RocketFire::fire()
+    {
+        Rocket* rocket = new Rocket(this);
+
+        this->computeMuzzleParameters(this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn()->getAimPosition());
+        rocket->setOrientation(this->getMuzzleOrientation());
+        rocket->setPosition(this->getMuzzlePosition());
+        rocket->setVelocity(this->getMuzzleDirection() * this->speed_);
+        rocket->scale(2);
+
+        rocket->setOwner(this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn());
+        rocket->setDamage(this->getDamage());
+    }
+}
Index: code/branches/pickup2/src/modules/weapons/weaponmodes/RocketFire.h
===================================================================
--- code/branches/pickup2/src/modules/weapons/weaponmodes/RocketFire.h	(revision 6412)
+++ code/branches/pickup2/src/modules/weapons/weaponmodes/RocketFire.h	(revision 6412)
@@ -0,0 +1,50 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _RocketFire_H__
+#define _RocketFire_H__
+
+#include "weapons/WeaponsPrereqs.h"
+#include "weaponsystem/WeaponMode.h"
+
+namespace orxonox
+{
+    class _WeaponsExport RocketFire : public WeaponMode
+    {
+        public:
+            RocketFire(BaseObject* creator);
+            virtual ~RocketFire();
+
+            virtual void fire();
+
+        private:
+            float speed_;
+    };
+}
+
+#endif /* _RocketFire_H__ */
